package com.qs5501.demo;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.zyapi.CommonApi;
import android.zyapi.Conversion;

import com.qs.wiget.App;
import com.qs5501demo.aidl.R;

public class PSAMActivity extends Activity implements OnClickListener {

	private TextView show, status;
	private EditText msg;
	private Button po1, po2, po3, cmd, pof;
	CommonApi mCommonApi;
	private int mComFd = -1;
	static ReadThread mReadThread;
	Handler handler;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_psam);
		
		
//		mCommonApi = new CommonApi();
		
//		mComFd = mCommonApi.openCom("/dev/ttyMT1", 115200, 8, 'N', 1);
		
		
		init();
		mReadThread = new ReadThread();
		mReadThread.start();

		handler = new Handler() {
			public void handleMessage(Message msg) {
				switch (msg.what) {
				case 1:
					String str = (String) msg.obj;
					status.setText(str);
					break;
				}
				super.handleMessage(msg);
			}

		};
		
		App.isScan=true;
	}

	
//	public  void initGPIO() {
//		// TODO Auto-generated method stub
//		
//	
//	
//		
//	}

	public  void openGPIO() {

		mCommonApi=App.getCommonApi();
		mComFd = mCommonApi.openCom("/dev/ttyMT1", 115200, 8, 'N', 1);
		
		mCommonApi.setGpioDir(12, 0);
		mCommonApi.getGpioIn(12);

		mCommonApi.setGpioDir(12, 1);
		mCommonApi.setGpioOut(12, 1);
		
	}
	
	private void init() {
		// TODO Auto-generated method stub
		show = (TextView) findViewById(R.id.textView_v);
		show.setText("");
		status = (TextView) findViewById(R.id.textView_s);
		status.setText("");
		msg = (EditText) findViewById(R.id.editText_msg);
		msg.setText("0084000004");
		// msg.setText("02000C010009E01400A400000211004703");

		po1 = (Button) findViewById(R.id.button_p1);
		po1.setOnClickListener(this);
		po2 = (Button) findViewById(R.id.button_p2);
		po2.setOnClickListener(this);

		cmd = (Button) findViewById(R.id.button_cmd);
		cmd.setOnClickListener(this);
		cmd.setEnabled(false);
		pof = (Button) findViewById(R.id.button_off);
		pof.setOnClickListener(this);
		pof.setEnabled(false);
		
		openGPIO();
//		initGPIO();
		
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		App.isScan=false;
		mReadThread.interrupt();
		mCommonApi.closeCom(mComFd);
		super.onDestroy();
	}

	@Override
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		if (arg0 == po1) {
			
//			/**
//			 * 1ESC ##PSAM n nL 
//			 * ʽ ASCII ESC # # P S A M n nL 
//			 * ʮ 1B 23 23  50 53 41 4D 
//			 * ʮ 27 35 35 80 83 65 77 
//			 * ܣȡpsamλϢpsamͨѶ
//			 * ˵
//			 * nֵΪ0x010x31ʾpsam1ͨѶ
//			 * nֵΪ0x020x32ʾpsam2ͨѶ
//			 * nLֵҪpsam͵ݳ nLֵΪ0x00Ҫ͵ĳΪ0ʾλpsam Ϊ0Ҫ͵ֽڳȼӵnL棻 
//			 * ע⣺ݻ߸λ ûλݣ psamδpsamݷǴӡյpsamݾλظ
//			 * κָͷΡ
//			 */
			byte[] send_po1 = new byte[] { 0x1B, 0X23, 0X23, 0X50, 0X53, 0X41,
					0X4D, 0x02,0x00 };
			
//			byte[] send_po1 = new byte[] {
//					0x1B, 0X23, 0X23, 0X43, 0X41, 0X52,0X44, 0x00
//					};
//			
			//
			send(send_po1);
			
			Toast.makeText(getApplicationContext(), "psam1 λ", 0).show();
	
		} else if (arg0 == po2) {
	
			byte[] send_po2 = new byte[] { 0x1B, 0X23, 0X23, 0X50, 0X53, 0X41,
					0X4D, 0x01,0x00 };
			
			send(send_po2);
			
			Toast.makeText(getApplicationContext(), "psam2 λ", 0).show();
			
		} else if (arg0 == po3) {

		} else if (arg0 == cmd) {
			String mCmd = msg.getText().toString().trim();
			if (mCmd == null)
				return;
			byte[] mApdu = null;
			try {
				mApdu = Conversion.HexString2Bytes(mCmd);
			} catch (Exception e) {
				e.printStackTrace();
				status.setText("Invalid char, cmd shoud formed by HEX number");
			}

			if (mApdu == null) {
				status.setText("Invalid mApdu, cmd shoud formed by HEX number");
				return;
			}

		}
	}

	class ReadThread extends Thread {
		@Override
		public void run() {
			super.run();
			while (!isInterrupted()) {
				int size = 0;
				byte[] buffer = new byte[256 + 1];
				size = mCommonApi.readCom(mComFd, buffer, buffer.length);
				if (size > 0) {
					String str1 = "-1";
					str1 = new String(buffer);
					Log.e("", "date:" + str1);
					
					String str2=byteToString(buffer, size);

					Message message = new Message();
					message.what = 1;
					message.obj ="ַ" +str1+"\nֽ飺"+str2;
					handler.sendMessage(message);
				}
			}
		}

	}
	
	public String byteToString(byte[] b, int size) {
		byte high, low;
		byte maskHigh = (byte) 0xf0;
		byte maskLow = 0x0f;

		StringBuffer buf = new StringBuffer();

		for (int i = 0; i < size; i++) {
			high = (byte) ((b[i] & maskHigh) >> 4);
			low = (byte) (b[i] & maskLow);
			buf.append(findHex(high));
			buf.append(findHex(low));
			buf.append(" ");
		}
		return buf.toString();
	}
	
	private char findHex(byte b) {
		int t = new Byte(b).intValue();
		t = t < 0 ? t + 16 : t;
		if ((0 <= t) && (t <= 9)) {
			return (char) (t + '0');
		}
		return (char) (t - 10 + 'A');
	}
	
	/**
	 * 
	 */
	public void send(byte[] data) {
		if (data == null)
			return;
			mCommonApi.writeCom(mComFd, data, data.length);

	}

}
